"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _react = _interopRequireDefault(require("react"));

var _hooks = require("../../../hooks");

var _stateHandlers = _interopRequireDefault(require("../../stateHandlers"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function useFirebaseDatabaseValue(path) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      orderByChild = _ref.orderByChild,
      orderByKey = _ref.orderByKey,
      orderByValue = _ref.orderByValue,
      orderByPriority = _ref.orderByPriority,
      limitToFirst = _ref.limitToFirst,
      limitToLast = _ref.limitToLast,
      startAt = _ref.startAt,
      endAt = _ref.endAt,
      equalTo = _ref.equalTo;

  var firebase = (0, _hooks.useFirebaseContext)();

  var _useStateHandlers = (0, _stateHandlers["default"])(),
      _useStateHandlers2 = _slicedToArray(_useStateHandlers, 2),
      value = _useStateHandlers2[0],
      setValue = _useStateHandlers2[1].set;

  var setValueFromSnapshot = _react["default"].useCallback(function (dataSnapshot) {
    return setValue(dataSnapshot.val());
  }, [setValue]);

  _react["default"].useEffect(function () {
    var reference = firebase.database().ref(path); // order-by methods

    if (orderByChild) {
      reference = reference.orderByChild(orderByChild);
    } else if (orderByKey) {
      reference = reference.orderByKey();
    } else if (orderByValue) {
      reference = reference.orderByValue();
    } else if (orderByPriority) {
      reference = reference.orderByPriority();
    } // query methods


    if (limitToFirst) {
      reference = reference.limitToFirst(limitToFirst);
    } else if (limitToLast) {
      reference = reference.limitToLast(limitToLast);
    } else if (startAt) {
      reference = reference.startAt(startAt);
    } else if (endAt) {
      reference = reference.endAt(endAt);
    } else if (!_lodash["default"].isNil(equalTo)) {
      // so you can filter by falsey value
      reference = reference.equalTo(equalTo);
    }

    reference.on('value', setValueFromSnapshot);
    return function cleanup() {
      reference.off('value', setValueFromSnapshot);
    };
  }, [firebase, path, setValue]);

  return value;
}

var _default = useFirebaseDatabaseValue;
exports["default"] = _default;