"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _class = _interopRequireDefault(require("../class"));

var _context = _interopRequireDefault(require("../context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 
 * @param {FirebaseConfig} config 
 * @param {FirebaseProduct[]} products 
 */
var provideFirebaseMiddleware = function provideFirebaseMiddleware(config, products) {
  var firebase = new _class["default"](config, products);

  var FirebaseProvider = function FirebaseProvider(_ref) {
    var children = _ref.children;
    return _react["default"].createElement(_context["default"].Provider, {
      value: firebase
    }, children);
  };

  var reduxMiddleware = function reduxMiddleware(store) {
    return function (next) {
      return function (action) {
        return next(_objectSpread({}, action, {
          firebase: firebase
        }));
      };
    };
  };

  return [FirebaseProvider, reduxMiddleware, firebase];
};

var _default = provideFirebaseMiddleware;
exports["default"] = _default;